# archlinux64

Builds Amazon AMI images for the **archlinux64** image built using the scripts
from the [archlinux64-qemu] repository.

-------------------------------------------------------------------------------

## Live Image Identifiers

Use the following AWS CLI commands to find the current AMI ID for this image.
All images are EBS-backed HVM AMIs.

### eu-west-1

```
aws ec2 describe-images                                         \
  --region eu-west-1                                            \
  --owners 656332075272                                         \
  --filters "Name=name,Values=archlinux64/linux/x86_64/hvm/ebs" \
  --query "Images[*].ImageId"                                   \
  --output text
```

### eu-west-2:

```
aws ec2 describe-images                                         \
  --region eu-west-2                                            \
  --owners 656332075272                                         \
  --filters "Name=name,Values=archlinux64/linux/x86_64/hvm/ebs" \
  --query "Images[*].ImageId"                                   \
  --output text
```

### Other Regions:

EC2 images are *beta*! Hence why they are only in the **EU** regions for now
and some functionality is missing. Currently GPU drivers for GPU instances are
not present.

-------------------------------------------------------------------------------

## Image Details

Please see: https://gitlab.com/bitservices/packer/archlinux64-qemu/blob/latest/README.md

-------------------------------------------------------------------------------

## How to 'Roll Your Own'

The process of creating this image has been automated as much as possible and
all code used in doing so has been uploaded into this repository.

In order to create this image on your own system, whether it be you would like
to customise the image or just for piece of mind, the process is as follows:

### Prerequisites

You will need the following:

* Access to a Linux Desktop with standard tools available such as Bash and Git.
* Packer from Hashicorp: https://www.packer.io/
* An EC2 image artifact in S3 generated by [archlinux64-qemu]

### Amazon AMI

1. Clone the git repository:
```
git clone https://gitlab.com/bitservices/packer/archlinux64-aws.git
```

2. Make sure you are in the correct folder to run Packer:
```
cd archlinux64-aws
```

3. Make any changes you wish to make to the packer HCL. At a minimum you will
need to change:
```
archlinux64/main.pkr.hcl: role              - ARN of an IAM role that Packer can use to create a temporary EC2 instance to build the image with.
archlinux64/main.pkr.hcl: bucket            - The full S3 bucekt name that contains the ec2 artifact generated by archlinux64-qemu.
archlinux64/main.pkr.hcl: s3_file           - A file within an S3 bucket that contains the ec2 artifact generated by archlinux64-qemu.
archlinux64/source.pkr.hcl: source_iam_role - ARN of an IAM role that you have permission to pass to the instance started by Packer that will allow it to get the ec2 artifact from S3.
```

4. Make sure your AWS CLI configuration is correct. Make sure the following
variables are set:
```
AWS_PROFILE: If you need to use non-default credentials to assume the Packer role successfully
```

5. Run Packer against the `archlinux64` folder:
```
packer build archlinux64
```

6. Observe any output or errors. If everything is successful the newly created
AMI images have their IDs printed to **stdout**.

-------------------------------------------------------------------------------

[archlinux64-qemu]: https://gitlab.com/bitservices/packer/archlinux64-qemu/
